#include "text.h"
#include <strings.h>

CTextFont LVFont;



bool CTextFont::LoadFont(char *File) //ielaadeejam fonta textuuru - labaak gan, lai
{                                   //taa buutu 32bit TGA - ar alpha kanaalu, lai
    if(!LoadTexture(File,&Font))    //fons paliek caurspiidiigs
    {
        printf("Nevaru ielaadeet fontu %s\n",File);
        return false;    
    }
    return true;
}


//argumetni - pats teksts, atrashanaas vieta, viena burta izmers un 
//parametri, kas nosaka, kaa tekstu pozicioneet pret noraadiito punktu pa x un y asiim  
void CTextFont::Write(char *Text,float Xpos,float Ypos,float Xsize,
           float Ysize,int AlignHorizontal,int AlignVertical)
{
    int len=strlen(Text);
    
    int CurChar,cx,cy;
    float Xe=Xpos+Xsize,Ye=Ypos+Ysize,Xs=Xpos,Ys=Ypos;//sakuma poziicijas, kur noraadiitaa
                                        //poziicija ir kreisais augsheejais stuuris textam
    if(AlignVertical==ALIGN_CENTER) //ja pa Y vajag textu nocentreet - paceljam pus 
    {                               //fonta augstumu uz augshu
        Ys-=Ysize*0.5f;
        Ye-=Ysize*0.5f;
    }
    if(AlignVertical==ALIGN_MAX) //ja pa Y vajag, lai noraadiitais punkts buutu apakshaa
    {                            //paceljam veselu fonta augstumu uz augshu
        Ys-=Ysize;
        Ye-=Ysize;
    }
    
    if(AlignHorizontal==ALIGN_CENTER) //ja pa X vajag textu nocentreet - pabiidam pus 
    {                                //pus teksta garumu pa kreisi
        Xs-=Xsize*0.5f*((float)len);
        Xe-=Xsize*0.5f*((float)len);
    }
    if(AlignHorizontal==ALIGN_MAX) //ja pa X vajag, lai noraadiitais punkts buutu labajaa 
    {                            //pusee textam - pabiidam visu texta garumu pa kreisi
        Xs-=Xsize*((float)len);
        Xe-=Xsize*((float)len);
    }  
        

    glBegin(GL_QUADS);
    for(CurChar=0;CurChar<len;CurChar++) //ejam cauri visam textam
    {
        cx=Text[CurChar]%16; //atrodam vajadziigaa burta X
        cy=Text[CurChar]/16; //un Y koordinaates textuuraa
        //lai noskaidrotu UV koordinaates - pareizinam ar 0.0625f - kas ir 1/16
        //taa ieguusim kreiso/augsheejo pusi, un pieskaitam veel 0.0625f - dabuusim labo/apaksheejo
        glTexCoord2f(0.0625f*(float(cx)),1.0f-0.0625f*(float(cy)));
        glVertex2f(Xs,Ys);
        glTexCoord2f(0.0625f*(float(cx)),1.0f-0.0625f*(float(cy+1)));
        glVertex2f(Xs,Ye);
        glTexCoord2f(0.0625f*(float(cx+1)),1.0f-0.0625f*(float(cy+1)));
        glVertex2f(Xe,Ye);
        glTexCoord2f(0.0625f*(float(cx+1)),1.0f-0.0625f*(float(cy)));
        glVertex2f(Xe,Ys);
        Xs=Xe; //un pabiidam quad'a poziciju
        Xe+=Xsize; //vienu uz priekshu
    }
    glEnd();      
}


    
void CTextFont::BindTexture()
{
    glBindTexture(GL_TEXTURE_2D,Font);
}


    
void CTextFont::UnLoadFont()
{
    glDeleteTextures(1,&Font);
}    

